/*

B-Free Project ʪ GNU Generic PUBLIC LICENSE ˽ޤ

GNU GENERAL PUBLIC LICENSE
Version 2, June 1991

(C) B-Free Project.

(C) 2001-2017, Tomohide Naniwa

*/
/* misc.c ---
 *
 */

#include "itron.h"

/*************************************************************************
 * halfword_swap
 *
 * 
 *
 * ͡
 *
 * 
 *
 */
UH halfword_swap(UH w)
{
    w = ((w & 0x00ff) << 8) | ((w & 0x00ff00) >> 8);
    return (w);
}

/**************************************************************************
 *
 *
 */
VP bcopy(VP src, VP dest, W count)
{
    B *sp, *dp;
    sp = (B *) src;
    dp = (B *) dest;
    while (count-- > 0) {
	*dp++ = *sp++;
    }
    return (dest);
}

/**************************************************************************
 *
 *
 */
void bzero(VP src, W count)
{
    B *sp;
    sp = (B *) src;
    while (count-- > 0) {
	*sp++ = 0;
    }
}

/**************************************************************************
 *
 *
 */
W strlen(B * buf)
{
    int i;

    for (i = 0; *buf++ != '\0'; i++);
    return (i);
}


/**************************************************************************
 *
 *
 */
W strcpy(B * s1, B * s2)
{
    int i;

    for (i = 0; *s2 != NULL; i++) {
	*s1++ = *s2++;
    }
    *s1 = '\0';
    return (i);
}

/**************************************************************************
 *
 *
 */
W strncmp(B * s1, B * s2, W size)
{
    W i;

    for (i = 0; i < size; ++i, ++s1, ++s2) {
	if ((*s1 - *s2 != 0) || (*s1 == '\0') || (*s2 == '\0'))
	    return (*s1 - *s2);
    }
    return (*s1 - *s2);
}

/**************************************************************************
 *
 *
 */
W strcmp(B * s1, B * s2)
{
    while ((*s1 == *s2) && (*s1)) {
	++s1;
	++s2;
    }
    return (*s1 - *s2);
}

W atoi(B * s)
{
    W result;
    BOOL minus = FALSE;

    result = 0;
    if (*s == '-') {
	s++;
	minus = TRUE;
    }

    while (*s != '\0') {
	result = (result * 10) + (*s - '0');
	s++;
    }
    return (minus ? -result : result);
}


char tolower(char c)
{
    if (c >= 'A') {
	if (c <= 'Z') {
	    return c - ('A' - 'a');
	}
    }
    return c;
}

char toupper(char c)
{
    if (c >= 'a') {
	if (c <= 'z') {
	    return c - ('a' - 'A');
	}
    }
    return c;
}
